//+------------------------------------------------------------------+
//|                                                     3xMAs#5 .mq4 |
//|                                                    Adapted by cja|
//+------------------------------------------------------------------+
#property copyright "By cja"

#property indicator_chart_window
#property indicator_buffers 7
#property indicator_color1 Aqua
#property indicator_color2 Yellow
#property indicator_color3 Magenta
#property indicator_color4 DodgerBlue
#property indicator_color5 Gold
#property indicator_color6 Lime
#property indicator_color7 Tomato
#property indicator_width1 1
#property indicator_width2 1
#property indicator_width3 2
#property indicator_width4 3
#property indicator_width5 3
#property indicator_width6 0
#property indicator_width7 0

//MODE_SMA 0 Simple moving average, 
//MODE_EMA 1 Exponential moving average, 
//MODE_SMMA 2 Smoothed moving average, 
//MODE_LWMA 3 Linear weighted moving average. 

//PRICE_CLOSE 0 Close price. 
//PRICE_OPEN 1 Open price. 
//PRICE_HIGH 2 High price. 
//PRICE_LOW 3 Low price. 
//PRICE_MEDIAN 4 Median price, (high+low)/2. 
//PRICE_TYPICAL 5 Typical price, (high+low+close)/3. 
//PRICE_WEIGHTED 6 Weighted close price, (high+low+close+close)/4. 


//---- input parameters
extern int EMAPeriod=3; 
extern int MA1_Type = 1;
extern int MA1_Price = 0;          
extern int EMAShift=0;             
extern int SEMAPeriod=7; 
extern int MA2_Type = 1;
extern int MA2_Price = 1;          
extern int SEMAShift=0;            
extern int SSEMAPeriod=25;
extern int MA3_Type = 0; 
extern int MA3_Price = 0;         
extern int SSEMAShift=0;
extern bool ShowPopUp_Main = true; 
extern bool ShowPopUp_Minor = true;
extern bool SoundAlert_ON = true;
extern string SoundFile ="alert"; 
extern bool SendEmail = false;
extern bool SoundAlert2_ON = true;
extern string SoundFile2 ="alert2"; 
extern bool SendEmail2 = false;
extern bool Show_Lines = true;
extern bool Show_Arrow2 = true; 

extern int Arrow_UP = 233; 
extern int Arrow_DN = 234; 
extern int Arrow_UP2 = 233; 
extern int Arrow_DN2 = 234; 
extern int Arrow_Distance = 15;      
//---- indicator buffers
double ExtBuffer1[];
double ExtBuffer2[];
double ExtBuffer3[];

double CrossUp[];
double CrossDown[];
double CrossUp2[];
double CrossDown2[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- line shifts when drawing
   SetIndexShift(0,EMAShift);
   SetIndexShift(1,SEMAShift);
   SetIndexShift(2,SSEMAShift);
//---- first positions skipped when drawing
   SetIndexDrawBegin(0,EMAShift+EMAPeriod);
   SetIndexDrawBegin(1,SEMAShift+SEMAPeriod);
   SetIndexDrawBegin(2,SSEMAShift+SSEMAPeriod);
//---- 3 indicator buffers mapping
   SetIndexBuffer(0,ExtBuffer1);
   SetIndexBuffer(1,ExtBuffer2);
   SetIndexBuffer(2,ExtBuffer3);
   
   SetIndexStyle(3, DRAW_ARROW);
   SetIndexArrow(3, Arrow_UP);
   SetIndexBuffer(3, CrossUp);
   SetIndexStyle(4, DRAW_ARROW);
   SetIndexArrow(4, Arrow_DN);
   SetIndexBuffer(4, CrossDown);
   
   SetIndexStyle(5, DRAW_ARROW);
   SetIndexArrow(5, Arrow_UP2);
   SetIndexBuffer(5, CrossUp2);
   SetIndexStyle(6, DRAW_ARROW);
   SetIndexArrow(6, Arrow_DN2);
   SetIndexBuffer(6, CrossDown2);
   
//---- drawing settings
  if(Show_Lines==true){
   SetIndexStyle(0,DRAW_LINE);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexStyle(2,DRAW_LINE);
   }
   else
   {
   SetIndexStyle(0,DRAW_NONE);
   SetIndexStyle(1,DRAW_NONE);
   SetIndexStyle(2,DRAW_NONE);
   }
//---- index labels
   SetIndexLabel(0,"MA "+EMAPeriod+"");   
   SetIndexLabel(1,"MA "+SEMAPeriod+"");   
   SetIndexLabel(2,"MA "+SSEMAPeriod+"");   
   SetIndexLabel(3,"MA"+SEMAPeriod+"  >  MA"+SSEMAPeriod+"");
   SetIndexLabel(4,"MA"+SEMAPeriod+"  <  MA"+SSEMAPeriod+"");
   SetIndexLabel(5,"MA"+EMAPeriod+"  >  MA"+SEMAPeriod+"");
   SetIndexLabel(6,"MA"+EMAPeriod+"  >  MA"+SEMAPeriod+"");
   
  
//---- initialization done
   return(0);
  }
 
//+------------------------------------------------------------------+
//| 5 X EMA                                          |
//+------------------------------------------------------------------+
int start()
  {
   static datetime dt = 0;
   int limit, i, counter;
     double fasterEMAnow, slowerEMAnow, fasterEMAprevious, slowerEMAprevious, fasterEMAafter, slowerEMAafter,
     midEMAprevious, midEMAafter, midEMAnow;
   double Range, AvgRange;
   int counted_bars=IndicatorCounted();
//---- check for possible errors
   if(counted_bars<0) return(-1);
//---- last counted bar will be recounted
   if(counted_bars>0) counted_bars--;

   limit=Bars-counted_bars;
   
   static datetime cDT = 0;
   for(i = 0; i <= limit; i++) {
   
      counter=i;
      Range=0;
      AvgRange=0;
      CrossUp[i] = 0; CrossDown[i] = 0; CrossUp2[i] = 0; CrossDown2[i] = 0;
      for (counter=i ;counter<=i+Arrow_Distance;counter++)// distance star above/below price 
      {
         AvgRange=AvgRange+MathAbs(High[counter]-Low[counter]);
      }
      Range=AvgRange/10;
      //iMA(Symbol(),0,1,0,MODE_EMA,PRICE_CLOSE,0); 
      fasterEMAnow = iMA(NULL,0,EMAPeriod,EMAShift,MA1_Type,MA1_Price,i);
      fasterEMAprevious = iMA(NULL,0,EMAPeriod,EMAShift,MA1_Type,MA1_Price,i+1);
      fasterEMAafter = iMA(NULL,0,EMAPeriod,EMAShift,MA1_Type,MA1_Price,i-1);
      
      midEMAnow = iMA(NULL,0,SEMAPeriod,SEMAShift,MA2_Type,MA2_Price,i);
      midEMAprevious = iMA(NULL,0,SEMAPeriod,SEMAShift,MA2_Type,MA2_Price,i+1);
      midEMAafter = iMA(NULL,0,SEMAPeriod,SEMAShift,MA2_Type,MA2_Price,i-1);

      slowerEMAnow = iMA(NULL,0,SSEMAPeriod,SSEMAShift,MA3_Type,MA3_Price,i);
      slowerEMAprevious =  iMA(NULL,0,SSEMAPeriod,SSEMAShift,MA3_Type,MA3_Price,i+1);
      slowerEMAafter =  iMA(NULL,0,SSEMAPeriod,SSEMAShift,MA3_Type,MA3_Price,i-1);
      
      if ((midEMAnow > slowerEMAnow ) && (midEMAprevious < slowerEMAprevious)) {
         CrossUp[i] = Low[i] - Range*0.75; // range # also affects star price difference
         if ((i < 2) && (dt != iTime(NULL,0,0)))
            {
             
            if(SoundAlert_ON==true)PlaySound(SoundFile);
             if (SendEmail==true)SendMail("3xMAs "+Symbol()+" M"+Period()+" ","MA"+SEMAPeriod+" > MA"+SSEMAPeriod+" Xrossed UP"+"\n"+Symbol()+" M"+Period()+", BUY  @ "+DoubleToStr(Bid,Digits)+"\n"
		     +"Time = "+TimeToStr(TimeLocal(),TIME_SECONDS)+"\n"+"Date = "+TimeToStr(TimeLocal(),TIME_DATE)+"");
		     if(ShowPopUp_Main){Alert("3xMAs "+Symbol()+" M"+Period()+" ","MA"+SEMAPeriod+" > MA"+SSEMAPeriod+" Xrossed UP");
		     
		        dt = iTime(NULL,0,0);
            }}
      }
      else  if ((midEMAnow < slowerEMAnow ) && (midEMAprevious > slowerEMAprevious)) {
         CrossDown[i] = High[i] + Range*0.75; // range # also affects star price difference
         if ((i < 2) && (dt != iTime(NULL,0,0)))
            {
            
            if(SoundAlert_ON==true)PlaySound(SoundFile);
              if (SendEmail==true)SendMail("3xMAs "+Symbol()+" M"+Period()+" ","MA"+SEMAPeriod+" < MA"+SSEMAPeriod+" Xrossed DN"+"\n"+Symbol()+" M"+Period()+", SELL  @ "+DoubleToStr(Bid,Digits)+"\n"
		     +"Time = "+TimeToStr(TimeLocal(),TIME_SECONDS)+"\n"+"Date = "+TimeToStr(TimeLocal(),TIME_DATE)+"");
		     if(ShowPopUp_Main){Alert("3xMAs "+Symbol()+" M"+Period()+" ","MA"+SEMAPeriod+" < MA"+SSEMAPeriod+" Xrossed DN");
               dt = iTime(NULL,0,0);
            }}
      }
      if(Show_Arrow2==true){
       if ((fasterEMAnow > midEMAnow ) && (fasterEMAprevious < midEMAprevious)) {
         CrossUp2[i] = Low[i] - Range*0.1; // range # also affects star price difference
         if ((i < 2) && (dt != iTime(NULL,0,0)))
            {
             
            if(SoundAlert2_ON==true)PlaySound(SoundFile2);
              if (SendEmail2==true)SendMail("3xMAs "+Symbol()+" M"+Period()+" ","MA"+EMAPeriod+" > MA"+SEMAPeriod+" Xrossed UP"+"\n"+Symbol()+" M"+Period()+", BUY  @ "+DoubleToStr(Bid,Digits)+"\n"
		     +"Time = "+TimeToStr(TimeLocal(),TIME_SECONDS)+"\n"+"Date = "+TimeToStr(TimeLocal(),TIME_DATE)+"");
		     if(ShowPopUp_Minor){Alert("3xMAs "+Symbol()+" M"+Period()+" ","MA"+EMAPeriod+" > MA"+SEMAPeriod+" Xrossed UP");
               dt = iTime(NULL,0,0);
            }}
      }
      else  if ((fasterEMAnow < midEMAnow ) && (fasterEMAprevious > midEMAprevious)) {
         CrossDown2[i] = High[i] + Range*0.1; // range # also affects star price difference
         if ((i < 2) && (dt != iTime(NULL,0,0)))
            {
            
            if(SoundAlert2_ON==true)PlaySound(SoundFile2);
               if (SendEmail2==true)SendMail("3xMAs "+Symbol()+" M"+Period()+" ","MA"+EMAPeriod+" < MA"+SEMAPeriod+" Xrossed DN"+"\n"+Symbol()+" M"+Period()+", SELL  @ "+DoubleToStr(Bid,Digits)+"\n"
		     +"Time = "+TimeToStr(TimeLocal(),TIME_SECONDS)+"\n"+"Date = "+TimeToStr(TimeLocal(),TIME_DATE)+"");
             if(ShowPopUp_Minor){Alert("3xMAs "+Symbol()+" M"+Period()+" ","MA"+EMAPeriod+" < MA"+SEMAPeriod+" Xrossed DN");
               dt = iTime(NULL,0,0);
            }}}
  
      }
   //for(int i=0; i<limit; i++)
     {
      //---- ma_shift set to 0 because SetIndexShift called above
      ExtBuffer1[i]=iMA(NULL,0,EMAPeriod,0,MA1_Type,MA1_Price,i); 
      ExtBuffer2[i]=iMA(NULL,0,SEMAPeriod,0,MA2_Type,MA2_Price,i); 
      ExtBuffer3[i]=iMA(NULL,0,SSEMAPeriod,0,MA3_Type,MA3_Price,i); 
     }}
    
//---- done
   return(0);
  }
//+------------------------------------------------------------------+

